-- 2012-01-31  Examples for FICS 2012 talk

-- Compositional termination with sized types

data List ++(A : Set) +(i : Size) : Set
{ nil  [j < i]                         : List A i
; cons [j < i] (a : A) (as : List A j) : List A i
}

fun everyOther : [A : Set] -> [i : Size] -> |i| -> List A i -> List A i
{ everyOther A i (nil j)                   = nil j
; everyOther A i (cons j a (nil k))        = nil j
; everyOther A i (cons j a (cons k a' as)) = cons j a (everyOther A j as)
}

fun zeroOneMany : [A : Set] -> [i : Size] -> List A i -> [C : +Size -> Set] -> 
  ([j < i] -> C i) ->                        -- zero
  ([j < i] -> A -> C i) ->                   -- one 
  ([j < i] -> A -> A -> List A j -> C i) ->  -- many
  C i
{ zeroOneMany A i (nil j)                   C zero one many = zero j
; zeroOneMany A i (cons j a (nil k))        C zero one many = one j a
; zeroOneMany A i (cons j a (cons k a' as)) C zero one many = many j a a' as
}

fun everyOther1 : [A : Set] -> [i : Size] -> |i| -> List A i -> List A i
{ everyOther1 A i l = zeroOneMany A i l (\ j -> List A j) 
    nil
    (\ j a       -> nil j)
    (\ j a a' as -> cons j a (everyOther1 A j as))
}
