module CantorCast where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate exmid : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refleq1 : Eq1 x x

  Eq1cong : ∀ {f g : Set -> Set} a -> Eq1 f g -> Eq1 (f a) (g a)
  Eq1cong a refleq1 = refleq1

  data I : (Set -> Set) -> Set where

  Iinj : ∀ { x y : Set -> Set } -> Eq1 (I x) (I y) -> Eq1 x y
  Iinj refleq1 = refleq1

  data invimageI (a : Set) : Set1 where
    invelmtI : forall x -> (Eq1 (I x) a) -> invimageI a

  cantor : Set -> Set
  cantor a with exmid (invimageI a)
  cantor a | inl (invelmtI x p) = x a -> Empty
  cantor a | inr b = One

  CANTOR : Set
  CANTOR = I cantor

  castRL : ∀ { A B } -> Eq1 A B -> B -> A
  castRL refleq1 a = a

  castLR : ∀ { A B } -> Eq1 A B -> A -> B
  castLR refleq1 a = a

  no : cantor (I cantor) -> Empty
  no f with exmid (invimageI (I cantor))
  no f | inl (invelmtI x p) = f (castRL (Eq1cong CANTOR (Iinj p)) f) 
{- ERROR:
(x (I cantor) → Empty) !=<
(cantor (I cantor) | exmid (invimageI (I cantor))) of type Set
-}
  no f | inr g = g (invelmtI (I cantor) refleq1)

  yes : cantor CANTOR
  yes with exmid (invimageI CANTOR)
  yes | inl (invelmtI x p) = λ f -> castLR (Eq1cong CANTOR (Iinj p)) f f
{- ERROR:
cantor (I cantor) | exmid (invimageI (I cantor)) should be a
function type, but it isn't
-}
  yes | inr g = one

  russell : Empty
  russell = no yes
