-- MiniAgda Prelude 

-- AUTOMATICALLY GENERATED FILE
-- DO NOT EDIT THIS FILE!  YOUR CHANGES WILL BE LOST!

-- 2012-02-01 MiniAgda Library (not universe polymorphic)

-- Leibniz equality  (the only family)

data Id [A : Set](a : A) : A -> Set
{ refl : Id A a a
}

fun subst : [A : Set] -> [P : A -> Set] -> [a, b : A] -> Id A a b -> P a -> P b
{ subst A P a .a refl h = h
}

fun cong : [A : Set] -> [B : A -> Set] -> [f : (x : A) -> B x] -> 
  [a, b : A] -> (p : Id A a b) -> 
  Id (B b) (subst A B a b p (f a)) (f b)
{ cong A B f a .a refl = refl
}

-- Enumerations and sums

data Empty {}
data Unit { unit }

-- * Booleans

data Bool { true; false }

fun if : [A : Set] -> (b : Bool) -> (t, e : A) -> A
{ if A true  t e = t
; if A false t e = e
}

fun If : (b : Bool) -> ++(A, B : Set) -> Set
{ If true  A B = A
; If false A B = B
}

-- * Either: disjoint sum type

let Either ++(A, B : Set) = (b : Bool) & If b B A
pattern left  a = (false, a)
pattern right b = (true, b)

fun either : [A, B : Set] -> [C : Either A B -> Set] ->
  ((a : A) -> C (left a)) ->
  ((b : B) -> C (right b)) ->
  (x : Either A B) -> C x
{ either A B C l r (left  a) = l a
; either A B C l r (right b) = r b
}

fun EitherT : [A, B : Set] -> (A -> Set) -> (B -> Set) -> Either A B -> Set
{ EitherT A B l r (left  a) = l a
; EitherT A B l r (right b) = r b
}

let mapEither [A, B, A', B' : Set] (f : A -> A') (g : B -> B')
  : Either A B -> Either A' B'
  = either A B (\ x -> Either A' B') (\ a -> left (f a)) (\ b -> right (g b))

-- * Maybe: option type

let Maybe ++(A : Set) = Either Unit A
pattern nothing = left unit
pattern just a  = right a

let maybe [A, B : Set] (n : B) (j : A -> B) : Maybe A -> B
  = either Unit A (\ x -> B) (\ u -> n) j 

let mapMaybe [A, B : Set] (f : A -> B) : Maybe A -> Maybe B
  = mapEither Unit A Unit B (\ u -> u) f

-- * Trichonomy

data Three { one; two; three }

fun ThreeT : (t : Three) -> ++(A, B, C : Set) -> Set
{ ThreeT one   A B C = A
; ThreeT two   A B C = B
; ThreeT three A B C = C
}

let Tri ++(A, B, C : Set) = (t : Three) & ThreeT t A B C
pattern first  a = (one, a)
pattern second b = (two, b)
pattern third  c = (three, c)
-- nat.ma

-- Natural numbers

cofun Nat : +Size -> Set
{ Nat i = Maybe ([j < i] & Nat j)
}
pattern zero  = nothing
pattern suc n = just n

let succ [i : Size] (n : Nat i) : Nat $i = suc (i, n)

let oneN   : Nat 1 = suc (0, zero)
let twoN   : Nat 2 = suc (1, oneN)
let threeN : Nat 3 = suc (2, twoN)
let fourN  : Nat 4 = suc (3, threeN)

fun caseNat : [i : Size] -> |i| -> (n : Nat $i) -> 
  [C : Set] -> C -> ([i : Size] -> (m : Nat i) -> C) -> C
{ caseNat i zero          C z s = z
; caseNat i (suc (i', n)) C z s = s i' n
}

{- ERROR in TypeChecker!
fun caseNat : [i : Size] -> |i| -> (n : Nat $i) -> 
  [C : [j : Size] -> Nat j -> Set] ->
  C 0 zero ->
  ([i : Size] -> (m : Nat i) -> C i m) ->
  C $i n
{ caseNat i zero          C z s = z
; caseNat i (suc (i', n)) C z s = s i' n
}
-}

fun iterNat : [A : Set](f : A -> A)(a : A)[i : Size](n : Nat i) -> A
{ iterNat A f a i zero          = a
; iterNat A f a i (suc (i', n)) = iterNat A f (f a) i' n
}

fun pred : [i : Size] -> (n : Nat $i) -> Nat i
{ pred i zero = zero
; pred i (suc (j, n)) = n
}

fun plus : [i : Size] -> |i| -> (n : Nat i) -> 
           [j : Size] ->        (m : Nat j) -> Nat (i+j)
{ plus i zero          j m = m
; plus i (suc (i', n)) j m = suc (i'+j, plus i' n j m)
}

fun times : [i : Size] -> |i| -> (n : Nat i) -> (m : Nat #) -> Nat #
{ times i zero m = zero
; times i (suc (i', n)) m = plus # m # (times i' n m)
}

fun minus : [i : Size] ->        (n : Nat i) -> 
            [j : Size] -> |j| -> (m : Nat j) -> Nat i
{ minus i zero          j m             = zero
; minus i n             j zero          = n
; minus i (suc (i', n)) j (suc (j', m)) = minus i' n j' m
}

-- computes ceil(n/(m+1))
fun div' : [i : Size] -> |i| -> (n : Nat i) -> (m : Nat #) -> Nat i
{ div' i zero          m = zero
; div' i (suc (i', n)) m = suc (i', div' i' (minus i' n # m) m)
}

-- computes floor(n/m) if m>0, and 0 otherwise
check  -- Alternative definition 
  let div [i : Size] (n : Nat i) (m : Nat #) : Nat i
    = caseNat # m (Nat i) 
        zero 
        (\ oo pred_m -> div' i (minus i n # pred_m) pred_m)

check  -- Alternative definition 
  fun div : [i : Size] -> (n : Nat i) -> (m : Nat #) -> Nat i
  { div i n zero = zero
  ; div i n m    = div' i (minus i n # (pred # m)) (pred # m)
  }

-- computes floor(n/m) if m>0, and 0 otherwise
fun div : [i : Size] -> (n : Nat i) -> (m : Nat #) -> Nat i
{ div i n zero          = zero
; div i n (suc (j, m')) = div' i (minus i n # m') m'
}

-- Comparing natural numbers

let Compare +(i, j : Size) = Tri (Nat i) Unit (Nat j)
pattern greater n = first n
pattern equal     = second unit
pattern less m    = third m

-- compares two numbers and returns the difference
fun compare : [i : Size] -> |i| -> (n : Nat i) ->
              [j : Size] ->        (m : Nat j) -> Compare i j
{ compare i zero          j zero          = equal
; compare i n             j zero          = greater n
; compare i zero          j m             = less m
; compare i (suc (i', n)) j (suc (j', m)) = compare i' n j' m
}

-- greatest common divisor
fun gcd : [i : Size] -> (n : Nat i) ->
          [j : Size] -> (m : Nat j) -> |i,j| -> Nat (max i j)
{ gcd i zero          j m             = m
; gcd i n             j zero          = n
; gcd i (suc (i', n)) j (suc (j', m)) = case compare i' n j' m
  { (equal)      -> suc (i', n)
  ; (greater n') -> gcd i' n' j (suc (j', m))
  ; (less m')    -> gcd i (suc (i', n)) j' m'
  }
}

-- list.ma -- MiniAgda list library

cofun List : ++(A : Set) -> +(i : Size) -> Set
{ List A i = Maybe (A & [i' < i] & List A i') 
}
pattern nil      = nothing
pattern cons a l = just (a, l) 

let consL [A : Set] [i : Size] (a : A) (as : List A i) : List A $i
  = cons a (i, as)

-- foldr

fun foldr : [A : Set] -> [B : Size -> Set] -> 
  ([i : Size] -> A -> [j < i] -> B j -> B i) ->
  ([i : Size] -> B i) -> 
  [i : Size] -> List A i -> B i
{ foldr A B f b i nil                = b i
; foldr A B f b i (cons a (j<i, as)) = f i a j (foldr A B f b j as)
}

-- map

check
let mapList : [A, B : Set] -> (A -> B) -> [i : Size] -> List A i -> List B i
  = \ A B f -> foldr A (List B) 
       (\ i a j bs -> cons (f a) (j, bs))   
       (\ i -> nil)

fun mapList : [A, B : Set] -> (A -> B) -> [i : Size] -> List A i -> List B i
{ mapList A B f i nil = nil
; mapList A B f i (cons a (j, as)) = cons (f a) (j, mapList A B f j as)
}

-- append

check
let append : [A : Set] -> 
             [i : Size] -> List A i -> 
             [j : Size] -> List A j -> List A (i+j)
  = \ A i as j bs -> 
      foldr A (\ i -> List A (i+j)) 
        (\ i b i' bs -> cons b (i'+j, bs)) 
        (\ i -> bs) 
        i 
        as

fun append : [A : Set] -> 
             [i : Size] -> |i| -> List A i -> 
             [j : Size] -> List A j -> List A (i+j)
{ append A i nil                 j bs = bs
; append A i (cons a (i'<i, as)) j bs = cons a (i'+j, append A i' as j bs)
}

-- drop

fun drop : [A : Set ] -> Nat # -> 
           [j : Size] -> List A j -> List A j
{ drop A zero j l                     = l
; drop A n    j nil                   = nil
; drop A n    j (cons a (j' < j, as)) = drop A (pred # n) j' as
}

-- take for lists is take for colists after embedding

-- fold left

check
fun foldl : [A, B : Set] -> (B -> A -> B) -> B ->
            [i : Size] -> List A i -> B
{ foldl A B f acc i nil = acc
; foldl A B f acc i (cons a (j, as)) = foldl A B f (f acc a) j as
}

-- fold left from fold right

let foldl' : [A : Set] -> [B : Set] -> (B -> A -> B) -> 
  [i : Size] -> List A i -> B -> B
  = \ A B f -> foldr A (\ i -> B -> B) 
      (\ i a j r acc -> r (f acc a))
      (\ i acc -> acc)

let foldl : [A : Set] -> [B : Set] -> (B -> A -> B) -> B ->
  [i : Size] -> List A i -> B
  = \ A B f b i l -> foldl' A B f i l b      

-- reverse

let revApp [A : Set] (as : List A #) (bs : List A #) : List A # 
  = foldl A (List A #) (\ as a -> consL A # a as) bs # as

let reverse [A : Set] (as : List A #) : List A #
  = revApp A as nil

-- colist.ma -- MiniAgda colist library

cofun CoList : ++(A : Set) -> -(i : Size) -> Set
{ CoList A i = Maybe (A & ([i' < i] -> CoList A i')) 
}

fun colist : [A : Set] -> [i : Size] -> |i| -> List A i -> CoList A i
{ colist A i nil               = nil
; colist A i (cons a (i', as)) = cons a (\ i'' -> colist A (max i' i'') as)
}  

fun cotake : [A : Set] -> [i : Size] -> Nat i -> CoList A i -> List A i
{ cotake A i zero          as         = nil
; cotake A i n             nil        = nil
; cotake A i (suc (i', n)) (cons a l) = cons a (i', cotake A i' n (l i'))
}

fun codrop : [A : Set ] -> 
             [i : Size] -> Nat i -> 
             [j : Size] -> CoList A (j+i) -> CoList A j
{ codrop A i zero          j l          = l
; codrop A i n             j nil        = nil
; codrop A i (suc (i', n)) j (cons a l) = codrop A i' n j (l (j+i'))
}

-- direct encoding of tail
check
fun cotail : [A : Set] [i : Size] (l : CoList A $i) -> CoList A i
{ cotail A i nil        = nil
; cotail A i (cons a l) = l i 
}

-- tail as instance of drop
let cotail [A : Set] : [i : Size] (l : CoList A $i) -> CoList A i
  = codrop A $0 (suc (0, zero))

fun coappend : [A : Set] -> [i : Size] -> |i| -> 
               CoList A i -> CoList A i -> CoList A i
{ coappend A i nil        bs = bs
; coappend A i (cons a l) bs = cons a (\ i' -> coappend A i' (l i') bs)
}

-- list take

let take [A : Set] [i : Size] (n : Nat i) (as : List A i) : List A i 
  = cotake A i n (colist A i as) 

{-

fun cotail : [A : Set] -> [i : Size] -> CoList A $i -> CoList A i
{ cotail A i l = case l
   { nil -> nil
   ; (cons a as) -> cons a (\ j -> as $j

mapMaybe (A & ([i' < $i] -> CoList A i'))  
                        (A & ([i' < i] -> CoList A i'))
    
}
-}-- stream.ma -- MiniAgda stream library

cofun Stream : ++(A : Set) -> -(i : Size) -> Set
{ Stream A i = A & ([i' < i] -> Stream A i')
}

fun head : [A : Set] [i : Size] (s : Stream A i) -> A
{ head A i (a , as) = a
}
fun tail : [A : Set] [i < #] (s : Stream A $i) -> Stream A i
{ tail A i (a , as) = as i
}

fun sTake : [A : Set] [i : Size] (n : Nat i)(s : Stream A i) -> List A i
{ sTake A i zero          s        = nil
; sTake A i (suc (i', n)) (a , as) = cons a (i', sTake A i' n (as i'))
}

let sDrop [A : Set] (n : Nat #) (s : Stream A #) : Stream A #
  = iterNat (Stream A #) (tail A #) s # n

fun zipWith2 : [A, B, C : Set] (f : A -> B -> C) -> 
  [i : Size] -> |i| -> Stream A i -> Stream B i -> Stream C i
{ zipWith2 A B C f i (a , as) (b , bs) = f a b , \ j -> 
    zipWith2 A B C f j (as j) (bs j) 
}

-- Bisimilarity

cofun StreamEq : [A : Set] (as, bs : Stream A #) -(i : Size) -> Set
{ StreamEq A as bs i = Id A (head A # as) (head A # bs) &
   ([i' < i] -> StreamEq A (tail A # as) (tail A # bs) i') 
}

-- Defining the n-ary zipwith

data MAYBE [a : Size] ++(A : Set a) : Set a
{ Nothing : MAYBE a A
; Just    : A -> MAYBE a A 
}

cofun LIST : [a : Size] ++(A : Set a) +(i : Size) -> Set a 
{ LIST a A i = MAYBE a ([i' < i] & A & LIST a A i')
}

fun Map : [a : Size] [A, B : Set a] (f : A -> B) 
  [i : Size] -> LIST a A i -> LIST a B i
{ Map a' A B f i Nothing = Nothing
; Map a' A B f i (Just (i' , a , as)) = Just (i' , f a , Map a' A B f i' as)
}

fun Fun : [i : Size] -> LIST $0 Set i -> Set -> Set 
{ Fun i Nothing             C = C
; Fun i (Just (i' , A , L)) C = A -> Fun i' L C
}

let Sets +(i : Size) = LIST $0 Set i
let MapSets = Map $0 Set Set

--  zipWith' []    c k          = c , k
--  zipWith' (A:L) f k (a , as) = zipWith' L (f a) (k as) 

fun zipWith' : [i : Size] |i| (L : Sets i) [C : Set] (f : Fun i L C)
  [j : Size] 
  (k : [j' < j] -> 
       Fun i (MapSets (\ A -> Stream A j') i L) (Stream C j')) ->
  Fun i (MapSets (\ A -> Stream A j) i L) (Stream C j)
{ zipWith' i Nothing C c j cs = c , cs
; zipWith' i (Just (i' , A , L)) C f j k (a , as) =
   zipWith' i' L C (f a) j (\ j' -> k j' (as j'))
}

--  zipWith L f = zipWith' L f (zipWith L f)

fun zipWith : [i : Size] (L : Sets i) [C : Set] (f : Fun i L C)
  [j : Size] -> |j| -> Fun i (MapSets (\ A -> Stream A j) i L) (Stream C j) 
{ zipWith i L C f j = zipWith' i L C f j (zipWith i L C f) }

let repeat (A : Set)(a : A)[i : Size] : Stream A i
  = zipWith 0 Nothing A a i

let sMap (A, B : Set)(f : A -> B)[i : Size](s : Stream A i) : Stream B i
  = zipWith 1 (Just (0, A, Nothing)) B f i s

let sZipWith (A, B, C : Set)
  = zipWith 2 (Just (1, A, Just (0, B, Nothing))) C

fun iterate : [A : Set](f : A -> A)(a : A)[i : Size] |i| -> Stream A i
{ iterate A f a i = a , \ i' -> iterate A f (f a) i'
}

let upFrom : (n : Nat #)[i : Size] -> Stream (Nat #) i
  = iterate (Nat #) (succ #)
 
-- nested coinduction?

fun bla : (A : Set)(f : A -> A)(a : A)[i,j : Size] |i,j| -> 
  Stream (Stream A j) i
{ 
{-
bla A a i j = mapStream ([j' < j] -> Stream A j') (Stream A j) 
   (\ as -> a , as) i (bla A a i j') -- where to get j' from?
; 
bla A f a i j = iterate A f a j , \ i' -> 
  sMap (Stream A #) (Stream A #) (tail A #) i' (bla A f a i' #)
-}
bla A f a i j = iterate A f a j , \ i' -> 
  sZipWith (Nat #) (Stream A #) (Stream A #) (sDrop A) 
    i' (upFrom (suc (0, zero)) i') (bla A f a i' #)
}

let squares = sMap (Stream (Nat #) #) (Nat #) (head (Nat #) #) 
                # (bla (Nat #) (succ #) zero # #) 

eval let sq4 = sTake (Nat #) # fourN squares  -- [0,1,3,6]

{-
sq4 evaluates to 
(true , ((false , unit) , (3 , 
(true , ((true , (# , (false , unit))) , (2 , 
(true , ((true , (# , (true , (# , (true , (# , (false , unit))))))) , (1 , 
(true , ((true , (# , (true , (# , (true , (# , (true , (# , (true , (# , (true , (# , (false , unit))))))))))))) , (0 , (false , unit)))))))))))))
-}-- bintree.ma  Binary trees

cofun BinTree : ++(A : Set) -> +(i : Size) -> Set 
{ BinTree A i = let ++T = [j < i] & BinTree A j
                in  Maybe (T & A & T)
}
pattern leaf       = nothing
pattern node l a r = just (l, a, r)



-- stl.ma  Simply Typed Lambda calculus, implemented with de Bruijn indices

-- Types are unlabeled binary trees

let Ty = BinTree Unit
pattern base = leaf
pattern arrow a b = node a unit b

let arr [i : Size] (a, b : Ty i) : Ty $i
  = arrow (i, a) (i, b)

-- Contexts are lists of types
let Context = List (Ty #)

let extend [i : Size] (a : Ty #) (cxt : Context i) : Context $i
  = consL (Ty #) i a cxt

-- Well-typed variables

fun Var : [i : Size] -> |i| -> (cxt : Context i) -> ^(c : Ty #) -> Set
{ Var i nil               c = Empty
; Var i (cons a (j, cxt)) c = Either (Id (Ty #) a c) (Var j cxt c)
} 

-- Variables are a variant of natural numbers
pattern vzero   = left refl
pattern vsucc x = right x

let vzer (cxt : Context #) (a : Ty #) : Var # (extend # a cxt) a 
  = vzero

let vsuc (cxt : Context #) (a, b : Ty #) (x : Var # cxt a) 
  : Var # (extend # b cxt) a
  = vsucc x

-- Well-typed terms

cofun Term :  +(i : Size) -> (cxt : Context #) -> (c : Ty #) -> Set
{ Term i cxt c = 
    let ++T (cxt : Context #) (c : Ty #) = [j < i] & Term j cxt c 
    in  Tri (Var # cxt c)                              -- var
            ((a : Ty #) & T cxt (arr # a c) & T cxt a) -- app
            (case c                                    -- abs
             { (base)                -> Empty
             ; (arrow (j, a) (k, b)) -> T (extend # a cxt) b 
             })
}
pattern var x     = first x
pattern app a t u = second (a, t, u)
pattern abs t     = third t

-- Example terms

pattern v0 = vzero
pattern v1 = vsucc v0
pattern v2 = vsucc v1
pattern v3 = vsucc v2

pattern var0 = var v0
pattern var1 = var v1
pattern var2 = var v2
pattern var3 = var v3

let tyId : Ty # = arr # base base
let tmId : Term # nil tyId = abs (0, var0) 

let tyK : Ty # = arr # base tyId
let tmK : Term # nil tyK = abs (1, abs (0, var1))

let tyS : Ty # = arr # tyK (arr # tyId tyId)
let tmS : Term # nil tyS = abs (4, abs (3, abs (2, app base
  (1, app base (0, var2) (0, var0)) 
  (1, app base (0, var1) (0, var0)))))

-- Renamings

let Renaming (gamma, delta : Context #)
  = (a : Ty #) -> Var # delta a -> Var # gamma a

check
fun liftRen : (gamma, delta : Context #) -> (c : Ty #) -> 
  (rho : Renaming gamma delta) -> Renaming (extend # c gamma) (extend # c delta)
{ liftRen gamma delta c rho .c vzero    = vzero
; liftRen gamma delta c rho a (vsucc x) = vsucc (rho a x) 
}

let liftRen (gamma, delta : Context #) (c : Ty #) (rho : Renaming gamma delta) 
  : Renaming (extend # c gamma) (extend # c delta)
  = \ a y -> case y
    { (left p)  -> left p
    ; (right x) -> right (rho a x)
    }

fun rename : (gamma, delta : Context #) -> (c : Ty #) -> 
  [i : Size] -> Term i delta c -> Renaming gamma delta -> Term i gamma c
{ rename gamma delta c i (var x)             rho = var (rho c x)
; rename gamma delta c i (app a (j,t) (k,u)) rho = 
    app a (j, rename gamma delta (arr # a c) j t rho)
          (k, rename gamma delta  a          k u rho)
; rename gamma delta base                  i (abs ())    rho 
; rename gamma delta (arrow (k1,a) (k2,b)) i (abs (j,t)) rho = 
    abs (j, rename (extend # a gamma) (extend # a delta) b j t 
              (liftRen gamma delta a rho))
}

-- Substitutions

let Substitution +(i : Size) (gamma, delta : Context #)
  = (a : Ty #) -> Var # delta a -> Term i gamma a

let liftSubst (gamma, delta : Context #) (c : Ty #) 
      [i : Size] (sigma : Substitution i gamma delta) 
  : Substitution i (extend # c gamma) (extend # c delta)
  = \ a y -> case y
    { (left p)  -> var (left p)
    ; (right x) -> rename (extend # c gamma) gamma a i 
                     (sigma a x) (\ b x -> vsucc x)
    }

fun substitute : (gamma, delta : Context #) -> (c : Ty #) -> 
  [i : Size] -> |i| -> Term i delta c -> 
  [j : Size] -> Substitution j gamma delta -> Term (i+j) gamma c
{ substitute gamma delta c i (var x) j sigma = sigma c x
; substitute gamma delta c i (app a (i1, t) (i2, u)) j sigma =
    app a (i1+j, substitute gamma delta (arr # a c) i1 t j sigma)
          (i2+j, substitute gamma delta a           i2 u j sigma)
; substitute gamma delta base                    i (abs ())      j sigma 
; substitute gamma delta (arrow (k1, a) (k2, b)) i (abs (i', t)) j sigma =
    abs (i' + j, substitute (extend # a gamma) (extend # a delta) b i' t j 
                   (liftSubst gamma delta a j sigma))
}
